
package wb;


import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.*;

import org.apache.commons.beanutils.DynaBean;
import org.apache.struts.action.*;



public class BattleAction extends Action {


    public ActionForward execute(ActionMapping mapping,
				 ActionForm form,
				 HttpServletRequest request,
				 HttpServletResponse response)
	throws Exception {


		BattleForm battleForm = (BattleForm)form;
		
		Word word = new Word();
		word.setName(battleForm.getName());
		word.setWord(battleForm.getWord());

		
//		DynaBean battleForm = (DynaBean)form;
//		Word word = new Word();
//		word.setName((String)battleForm.get("name"));
//		word.setWord((String)battleForm.get("word"));


		BattleManager manager = BattleManager.getInstance(request);		


		if(manager.isDuplicateWord(word)){
			ActionErrors errors = new ActionErrors();
			errors.add("duplicate", new ActionError("error.word.duplicated"));

	    	saveErrors(request, errors);
	    	saveToken(request);
	    	return new ActionForward(mapping.getInput());

		}
		
		int rank = manager.battle(word);

		request.setAttribute("rank", new Integer(rank));
		request.setAttribute("word", word);
		//request.setAttribute("list", manager.getWords());


		return (mapping.findForward("success"));

    }


}

